;|									;;
	H O S 	COMMAND	-> Changed for DHATCH (Dynamic HATCH)		;;
 	(Hatch Object Scaling v. 2)					;;
	By: Andrea Andreetti dec. 2008					;;
									;;
	Update 1 - By: Ronjonp (theswamp)				;;
		Rotation angle revised					;;
									;;
	Update 2 - By Andrea Andreetti					;;
		ORTHOMODE added with F8					;;
		Color Switch from 1 to 9 				;;
		Switch Hatch Pattern during Rotation			;;
									;;
	Update 2.1 -By Andrea Andreetti					;;
		Fix1 :  ColorToggle variable added to fix		;;
			Color Swaping without rescaling the Hatch	;;
		Fix2 :	PatternToggle Variable added for same reason	;;
			when swapping the Hatch Pattern			;;
		Fix3 :	English and French message detection		;;
		HOS became DHATCH (dynamic Hatch)			;;
									;;
	Update 2.2 -By Andrea Andreetti					;;
		- New Feature allowing to move the HatchOrigin		;;
									;;
	Upgrade Dhatch v.3 -bY Andrea Andreetti 2008/12/23		;;
		-Solid Hatch accepted					;;
		-Work for Ellipse					;;
		-You can select object or click INSIDE a closed object	;;
		-New Options: (S)cale/(H)atch/(O)rigin/(C)olor		;;
		-You can change Origin in real time and continu the function.
		-Osnap follow the SNAPANG variable.			;;
		-Diffrent ggrdraw vector color when using the Origin option.
		-Color option show the 256 autoCAD color dialog Box during the hatch.
		-Auto-Language version detection. (French / English)	;;
									;;
	Update Dhatch v.3.1.0 -by Andrea Andreetti 2008/12/23		;;
		-Undo Redo management					;;
	Update dHATCH V.3.1.1 -by Andrea Andreetti 2008/12/23		;;
		-Case Sensitive when choosing options FIXED		;;
									;;
	Upgrade Dhatch 4.0 by Andrea Andreetti 2008/12/25		;;
		-New function DHEDIT (editor)				;;
	Update Dhatch 4.1 By A.A. 2008-12-28				;;
		DHSL DHatch String Language detection function		;;
	Update Dhatch 4.2 By A.A. 2008-12-29				;;
		Scale option allow to put Number Value			;;
	Update Dhatch 4.3 By A.A. 2008-12-30				;;
		Display Dynamic Angle and Scale				;;
	Update Dhatch 4.4 By A.A. 2009-01-07				;;
		Allow User to put any filename for Hatch Pattern.	;;
	Update Dhatch 4.5 By A.A. 2009-01-15				;;
		- Dynamic Menu Mtext added				;;
		- Selection change					;;
		- Associative Hatch when Selecting Object		;;
		- Allow Costum Hatch					;;
		- Input entry for any option				;;
									|;

(vl-load-com)
;;					;;
;;	FRENCH/ENGLISH DETEXTION	;;
;;					;;
					;;
(defun DHSL ()
(vl-load-com)  
(if (vl-string-search "(FR)" (strcase (ver)))
  (progn
    (setq mess1   "\nSelectionnez votre entit ou l'intrieur d'une Zone  Hachurer...")
    (setq mess2   "\n- Type de Hachure chang  : ")
    (setq mess3   "\nAppuyez sur ESPACE pour choisir/ENTRER pour diter/V pour entrer une Valeur::")
    (setq mess4   "\nSlectionnez l'hachure  diter : ")
    (setq mess5	  "\n(D)ynamique ou (V)aleur <D>: ")
    (setq mess6   "\nchelle Dynamique...")
    (setq mess7   "\nchelle de votre hachurage <")
    (setq mess8   ";chelle: ")
    (setq mess9   ";Angle: ")
    (setq mess10  ";Hachure: ")
    (setq mess11  ";Origine: ")
    (setq mess12  ";PAT file: ")

    (setq cmess0 "\nAppuyez sur ESPACE pour choisir/ENTRER pour activer/V pour entrer une Valeur:")
    (setq cmess1  "\nchelle :")
    (setq cmess2  "\nAngle :")
    (setq cmess3  "\nHachure :")
    (setq cmess4  "\nOrigine (liste) :")
    (setq cmess5  "\nCouleur :")
    
    (setq var256  "DUCALQUE")
    (setq var0    "DUBLOCK")
  )
  (progn    
    (setq mess1   "\nPlease pick Boundary or point inside hatch region")
    (setq mess2   "\n- Hatch Pattern Switched to : ")
    (setq mess3   "\nPress SPACE bar to Make a choice and than ENTER to edit:")
    (setq mess4   "\nPlease select Hatch to edit : ")    
    (setq mess5	  "\n(D)ynamic or (V)alue <D>: ")
    (setq mess6   "\nDynamic Scale...")
    (setq mess7   "\nEnter the Hatch Scale Value <")
    (setq mess8   ";Scale: ")    
    (setq mess9   ";Angle: ")
    (setq mess10  ";Pattern: ")
    (setq mess11  ";Origin: ")
    (setq mess12  ";PAT File: ")

    (setq cmess0  "\nPress SPACE bar for select/ENTRER to activate/V to enter a Value:")
    (setq cmess1  "\nNew Scale Value :")
    (setq cmess2  "\nNew Angle Value :")
    (setq cmess3  "\nNew Pattern Name :")
    (setq cmess4  "\nNew Origin Coordinates (list) :")
    (setq cmess5  "\nNew Color Value :")
    
    (setq var256  "BYLAYER")
    (setq var0    "BYBLOCK")
  )
)
)
					;;
;;					;;
;;	FRENCH/ENGLISH DETEXTION	;;
;;					;;




;;					;;
;;	DHATCH 	COMMAND			;;
;;					;;
					;;
(defun c:Dhatch (/ HatchEdition		 #DCswitch  dr_sel1
		   entVLA     OTD	 centerpoint
		   FicPoint   fi	 si	    LP
		   A_hps      DHSCA	 DHROT	    gkw
		   orthm      snapa	 hatchlist  hatch#
		   TD	      A_cecolor	 A_hpang    A_hpscale
		   A_hpname   A_hporigin hatchdata  FirstHatch
		   DHSCA      DHROT	 orthM	    mess1
		   mess2      mess3	 mess4	    mess5
		   mess6      mess7	 var256	    var0
		   LLpoint    URpoint	 EntAssoc   activeMODE
		   #op	      ARCENT	 NPAT	    input
		  )
(DHSL)  
(setq HatchEdition nil)
(setq OTD nil)  

(if (not #DCswitch)(setq #DCswitch 0))
(setq dr_sel1 nil)  
  (while (or
           (= dr_sel1 nil)
           (and
           (/= (cdr (assoc 0 (setq dr_sel1data (entget (car dr_sel1))))) "LWPOLYLINE")
           (/= (cdr (assoc 0 (setq dr_sel1data (entget (car dr_sel1))))) "CIRCLE")
	   (/= (cdr (assoc 0 (setq dr_sel1data (entget (car dr_sel1))))) "ELLIPSE")
           )
         )
(setq dr_sel1 (entsel mess1))
(if (not dr_sel1)
  (progn      
  (setq FicPoint (cadr (grread t 4 4)))
  (vl-cmdf "._boundary" FicPoint "")
    (setq dr_sel1 (list (setq TD (entlast)) FicPoint))
    (setq OTD T)
  )
  (setq EntAssoc (car dr_sel1))
  )
)   

(setq entVLA (vlax-ename->vla-object (car dr_sel1)))  
  
(if (or
      (eq (vla-get-ObjectName entVLA) "AcDbEllipse")
      (eq (vla-get-ObjectName entVLA) "AcDbCircle")
      (and
      (eq (vla-get-ObjectName entVLA) "AcDbPolyline")
      (eq (vla-get-Closed entVLA) :vlax-true)
      )
    )
(progn
(vla-GetBoundingBox entVLA 'x 'y)
(setq LLpoint  (vlax-safearray->list x))
(setq URpoint  (vlax-safearray->list y))
(setq centerpoint (polar LLpoint (angle LLpoint URpoint) (/ (distance LLpoint URpoint) 2)))
)
)

(redraw)

(vla-StartUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
(oHexecute) ;_while
 (while
   (and
     (not (= (car input) 25))		;RIGHT CLICK
     (not (= (car input) 11))		;RIGHT CLICK
     (not (= (car input) 3))		;LEFT CLICK
     (not (and (= (car input) 2) (= (cadr input) 32))) ;ESCAPE
     (not (and (= (car input) 2) (= (cadr input) 13))) ;ENTER
   )
    (oHexecute)
 )
 
  
(setq hatchent nil)
(if OTD (entdel TD))
(redraw)
(vla-EndUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object))) 
)
					;;
;;					;;
;;	DHATCH 	COMMAND			;;
;;					;;






;;				;;
;;	DHATCHEDIT		;;
;;				;;
				;;
(defun c:Dhatchedit (/)
(DHSL)  
(setq hatchdata nil)
(setq HatchEdition T)
(setq OTD nil)

(setq dr_sel1 nil)  
  (while (or
           (= dr_sel1 nil)
           (and
           (/= (cdr (assoc 0 (setq hatchdata (entget (car dr_sel1))))) "HATCH")
           )
         )
(setq dr_sel1 (entsel mess4))
    )


(setq entVLA (vlax-ename->vla-object (car dr_sel1)))
(vla-GetBoundingBox entVLA 'x 'y)
(setq LLpoint  (vlax-safearray->list x))
(setq URpoint  (vlax-safearray->list y))
(setq centerpoint (polar LLpoint (angle LLpoint URpoint) (/ (distance LLpoint URpoint) 2)))
(setq FirstHatch (car dr_sel1))
  
(redraw)
(vla-StartUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
(oHexecute)  
(setq hatchent nil)
(redraw)
(vla-EndUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
)
				;;
;;				;;
;;	DHATCHEDIT		;;
;;				;;




;;				;;
;;	Degree Conversion	;;
;;				;;
				;;
(defun dtr (a)
(* pi (/ a 180.0))
)

(defun rtd (a) 
(/ (* a 180) pi) 
)
				;;
;;				;;
;;	Degree Conversion	;;
;;				;;




;;				;;
;;	DHATCH 	ORTHOMODE	;;
;;				;;
				;;
(defun HOSortho (/ distP NorthP WestP EastP SouthP)


  
    (setq distP (distance centerpoint cursorpoint))
    (setq NorthP (polar centerpoint (+ snapA (dtr 90)) distP))
    (setq WestP  (polar centerpoint (+ snapA (dtr 180)) distP))
    (setq EastP  (polar centerpoint snapA distP))
    (setq SouthP (polar centerpoint (- snapA (dtr 90)) distP))
  
(if (and
      (< (distance cursorpoint NorthP) (distance cursorpoint WestP))
      (< (distance cursorpoint NorthP) (distance cursorpoint EastP))
      (< (distance cursorpoint NorthP) (distance cursorpoint SouthP))
    )
(setq cursorpoint NorthP)
)

(if (and
      (< (distance cursorpoint WestP) (distance cursorpoint NorthP))
      (< (distance cursorpoint WestP) (distance cursorpoint EastP))
      (< (distance cursorpoint WestP) (distance cursorpoint SouthP))
    )
(setq cursorpoint WestP)
)  

(if (and
      (< (distance cursorpoint EastP) (distance cursorpoint WestP))
      (< (distance cursorpoint EastP) (distance cursorpoint NorthP))
      (< (distance cursorpoint EastP) (distance cursorpoint SouthP))
    )
(setq cursorpoint EastP)
)

(if (and
      (< (distance cursorpoint SouthP) (distance cursorpoint WestP))
      (< (distance cursorpoint SouthP) (distance cursorpoint EastP))
      (< (distance cursorpoint SouthP) (distance cursorpoint NorthP))
    )
(setq cursorpoint SouthP)
)  
)
				;;
;;				;;
;;	DHATCH 	ORTHOMODE	;;
;;				;;








;;				;;
;;	DHATCH 	function	;;
;;				;;
				;;
(defun oHexecute (/ )
(setvar "CMDECHO" 0)
(setq orthm (getvar "ORTHOMODE"))
(setq snapa (getvar "SNAPANG"))
(setq Operation nil)


(if (eq (getvar "MEASUREMENT") 0)
    (setq bhatchf "acad.pat")
    (setq bhatchf "acadiso.pat")
)
  
;(setq hatchlist
       (gethatchlin (findfile bhatchf));)
 
 
(setq hatch# (1- (vl-list-length hatchlist)))
(setq #dcswitch (vl-position (setq A_hpname (getvar "HPNAME")) hatchlist))
(if (not #dcswitch)
  (progn
  (setq #dcswitch 0)
  (setq A_hpname (car hatchlist))
  )
)
  

(if (not HatchEdition)
  (progn
(vl-cmdf "_-hatch" "_A" "_A" "_N" "" "_S" (car dr_sel1) "" "")
(setq FirstHatch (entlast))
(setq hatchdata (entget FirstHatch))

    (setq A_cecolor (getvar "CECOLOR")
	  A_hpang (getvar "HPANG")
	  A_hpscale (getvar "HPSCALE")
	  A_hpname (getvar "HPNAME")
	  A_hporigin centerpoint)
)
  (progn
    (if (assoc 62 hatchdata)
      (setq A_cecolor (itoa (cdr (assoc 62 hatchdata))))
      (setq A_cecolor var256)
    )
    (setq A_hpscale (cdr (assoc 41 hatchdata)))
    (setq A_hpang  (cdr (assoc 53 hatchdata)))
    (setq A_hpname (cdr (assoc 2 hatchdata)))
    (setq A_hporigin centerpoint)
    (if (not (member (strcase A_hpname) HATCHLIST))
      (setq A_hpname (car HATCHLIST))
    )
  )
)


  
(setq activeMODE NIL) 
(setq #op 2)  
    (princ mess3)
    (while (and (setq input (grread t 4 4))		
                (or (= (car input) 5)				  ; *cursor
		    (and (= (car input) 2) (= (cadr input) 15))	  ; F8 Orthomode
		    (and (= (car input) 2) (= (cadr input) 13))	  ; ENTER
                    (and (= (car input) 2) (= (cadr input) 32))	  ; SPACE
                    (and (= (car input) 2) (= (cadr input) 9))	  ; TAB
                    (and (= (car input) 2) (= (cadr input) 118))  ; v
                    (and (= (car input) 2) (= (cadr input) 86))   ; V
                    (= (car input) 3)				  ; LEFT CLICK
                )
           )


      
(if ARCENT (progn
             (vl-cmdf "._erase" ARCENT "")
             (setq ARCENT nil)
            )
)


      
;cursor
(if (= (car input) 5) (setq cursorpoint (cadr input)))

    
      
;;SPACE
(if (and (= (car input) 2) (= (cadr input) 32)); SPACE
  (progn
    (setq Operation nil)
    (setq activeMODE nil)
    (setq input Lastinput)
    (setq cursorpoint (cadr input))
    (if (= #op 5)(setq #op 1)(setq #op (1+ #op)))
    )
)
      

; TAB
(if  (and (= #op 3) (= (car input) 2) (= (cadr input) 9))
  (progn
(if activeMODE
  (progn    
(if FirstHatch
  (if
    (eq (cdr (assoc 0 (entget FirstHatch))) "HATCH")
    (entdel FirstHatch)
  )
)
    (setq cursorpoint (cadr input))
    (if (acet-sys-shift-down)
      (progn
         (if  (<= #dcswitch 1)
         (setq #dcswitch hatch#)
         (setq #dcswitch (1- #dcswitch))
         )
      )
      (progn
         (if  (>= #dcswitch hatch#)
         (setq #dcswitch 1)
         (setq #dcswitch (1+ #dcswitch))
         )
      )
    )

    (setq A_hpname (nth #dcswitch hatchlist))

  )
)
)
)

(if (and (= (car input) 2) (= (cadr input) 9))
  (progn
    (setq input Lastinput)
    (setq cursorpoint (cadr input))    
  )
)    
      
  
;;ORTHO MODE
(if (and (= (car input) 2) (= (cadr input) 15))
  (setq Operation "ORTHO")
)
      


;;LEFT CLICK
(if (= (car input) 3)
  (progn    
    (setq lastOrigin cursorpoint)
    (setq activeMODE NIL)    
  )
)
      

;;ENTER
(if (and (= (car input) 2) (= (cadr input) 13))
    (progn
(if FirstHatch
  (if
    (eq (cdr (assoc 0 (entget FirstHatch))) "HATCH")
    (entdel FirstHatch)
  )
)      
    (setq activeMODE T)
    (setq input LastInput)
    )
 )      



;; VALUE
(if (or
      (and (= (car input) 2) (= (cadr input) 118))
      (and (= (car input) 2) (= (cadr input) 86))
    )
  (progn
  (setq Promt T)  
  (setq activeMODE T)
  )
)

      

;; Value
(if activeMODE
  (progn
(if FirstHatch
    (if
      (eq (cdr (assoc 0 (entget FirstHatch))) "HATCH")
      (entdel FirstHatch)
    )
)

(setq Valeur nil)
(if (or
      (and (= (car input) 2) (= (cadr input) 118))
      (and (= (car input) 2) (= (cadr input) 86))
    )
  (progn
    (if (= #op 1)(setq Valeur (getreal cmess1)))
    (if (= #op 2)(setq Valeur (getreal cmess2)))
    (if (= #op 3)(setq Valeur (getstring cmess3)))
    (if (= #op 4)(setq Valeur (getstring cmess4)))
    (if (= #op 5)(setq Valeur (getint cmess5)))
    (setq input Lastinput)
  )
)
)
)
      



;;***	COLOR
(if (eq #op 5)
  (progn
    (redraw)
    (grdraw centerpoint cursorpoint 12 1)
(if activeMODE
   (progn
     (if Promt
       (princ cmess0)
     )
     (setq Promt nil)
     (if (not Valeur)
       (progn
        (setq activeMODE nil)
        (setq ccol (read A_cecolor))
        (if (eq (strcase A_cecolor) "BYBLOCK") (setq ccol 0))
        (if (eq (strcase A_cecolor) "BYLAYER") (setq ccol 256))
	(setq Ncol nil)
        (setq Ncol (acad_colordlg ccol 8))
        (if Ncol
          (progn
(if FirstHatch
     (if
      (eq (cdr (assoc 0 (entget FirstHatch))) "HATCH")
      (entdel FirstHatch)
    )
)	    
            (setq A_cecolor (itoa Ncol))
            (if (eq Ncol 256)(setq A_cecolor "BYLAYER"))
            (if (eq Ncol 0)(setq A_cecolor "BYBLOCK"))
          )
        )
        (setq Operation nil)	
        (MODIFHATCH A_hpname A_cecolor A_hpang A_hpscale A_hporigin)
	(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 12 252) 
      )
      (progn
	(if (and (>= Valeur 0)(<= Valeur 256))
	  (progn
	(setq A_cecolor (itoa Valeur))
	(if (eq Valeur 256)(setq A_cecolor "BYLAYER"))
	(if (eq Valeur 0)(setq A_cecolor "BYBLOCK"))
	(setq Operation nil)
	
(if FirstHatch
     (if
      (eq (cdr (assoc 0 (entget FirstHatch))) "HATCH")
      (entdel FirstHatch)
    )
)	
	(MODIFHATCH A_hpname A_cecolor A_hpang A_hpscale A_hporigin)
	(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 12 252)
	  )
	)
	
      )
     )
     (setq activeMODE Nil)
     (setq Valeur nil)
     )
(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 12 252)  
  )
(setq Operation nil)    
    )
  )


;;***	HATCH PATTERN
(if (eq #op 3)
(progn  
(redraw)
(grdraw cursorpoint centerpoint 12 1)
 (if activeMODE
   (progn
     (if Promt
       (princ mess3)
     )
     (setq Promt nil)     
     (if (not Valeur)
       (progn
          (setq Operation nil)          
	  (MODIFHATCH A_hpname A_cecolor A_hpang A_hpscale A_hporigin)
	  (DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 5 A_hporigin 252 A_cecolor 252 252)
          (grdraw centerpoint cursorpoint 4 1)
        )
       (progn         
       (if (member (strcase Valeur) HATCHLIST)
         (progn           
           (setq A_hpname (strcase Valeur))           
           (MODIFHATCH A_hpname A_cecolor A_hpangX A_hpscale A_hporigin)
           (DHMTEXT 254 input A_hpscale 5 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
         )
       )
       (setq activeMODE nil)     
       )
     )
  )
(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 12 A_hporigin 252 A_cecolor 252 252)
)
(setq Operation nil)
	)	 
)

      
;;***	ORTHO
(if (eq Operation "ORTHO")
  (progn
    (setq input Lastinput)    
    (if (eq orthm 1)
           (progn
             (setvar "ORTHOMODE" 0)
             (setq orthm 0)
             (princ "\nORTHO: OFF")
             (princ mess3)
           )
           (progn
             (setvar "ORTHOMODE" 1)
             (setq orthm 1)
             (princ "\nORTHO: ON")
             (princ mess3))
         )
    (setq Operation nil)
  )
)
(if (eq orthM 1)
  (HOSortho) 
  )      


      


;;***	SCALE
(if (eq #op 1)
(progn
(redraw)
(grdraw cursorpoint centerpoint 12 1)
 (if activeMODE
   (progn
(if Promt
       (princ mess3)
     )
     (setq Promt nil)
     (if (not Valeur)
       (progn         
          (grdraw centerpoint cursorpoint 4 1)
          (setq input (grread t 4 4))
          (setq cursorpoint (cadr input))
	  (setq A_hpscale (distance cursorpoint centerpoint))
          (MODIFHATCH A_hpname A_cecolor A_hpang A_hpscale A_hporigin)
          (DHMTEXT 254 input A_hpscale 5 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
   )
   (progn
     (setq A_hpscale Valeur)
     (MODIFHATCH A_hpname A_cecolor A_hpangX A_hpscale A_hporigin)
     (DHMTEXT 254 input A_hpscale 5 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
     (setq activeMODE nil)     
   )
   )
     )
(DHMTEXT 254 input A_hpscale 12 A_hpang 252 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
)
(setq Operation nil)

	)	 
)

     


;;***	ANGLE
(if (eq #op 2)
(progn
(redraw)
(grdraw cursorpoint centerpoint 12 1)
(if activeMODE
   (progn
     (if Promt
       (princ mess3)
     )
     (setq Promt nil)     
     (if (not Valeur)
       (progn
     (setq A_hpangX (- LastAng (dtr 45)))     
     (setq A_hpang (angle centerpoint cursorpoint))
     (MODIFHATCH A_hpname A_cecolor A_hpangX A_hpscale A_hporigin)
     (GRDRAW_ANGLE)
     (setq entVLA (vlax-ename->vla-object hatchent))
     (vla-put-PatternAngle entVLA A_hpangX)   
     (setq hatchent (vlax-vla-object->ename entVLA))
     (setq hatchdata (entget hatchent))     
     (DHMTEXT 254 input A_hpscale 252 A_hpang 5 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
     )
       (progn
     (setq A_hpangX (- (dtr Valeur) (dtr 45)))    
     (MODIFHATCH A_hpname A_cecolor A_hpangX A_hpscale A_hporigin)
     (setq entVLA (vlax-ename->vla-object hatchent))
     (vla-put-PatternAngle entVLA A_hpangX)   
     (setq hatchent (vlax-vla-object->ename entVLA))
     (setq hatchdata (entget hatchent))
     (setq A_hpang (dtr Valeur))
     (DHMTEXT 254 input A_hpscale 252 A_hpang 5 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
     (setq activeMODE nil)
        )
       )
     
    )
  (DHMTEXT 254 input A_hpscale 252 A_hpang 12 A_hpname 252 A_hporigin 252 A_cecolor 252 252)
) 
	  (setq Operation nil)
	)
 
    
  )


;;***	ORIGIN
(if (eq #op 4)
(progn
(redraw)
(grdraw lastOrigin cursorpoint 12 1)
  (if activeMODE
   (progn
(if Promt
       (princ mess3)
     )
     (setq Promt nil) 
     (if (not Valeur)
       (progn
(grdraw lastOrigin cursorpoint 4 1)     
(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 252 cursorpoint 5 A_cecolor 252 252)     
(setq cursorX (car cursorpoint))
(setq cursorY (cadr cursorpoint))
(if hatchent
  (progn    
(setq hatchentData (entget hatchent))
(setq hatchdatax (subst (cons 43 cursorX)(assoc 43 hatchentData) hatchentData))
(setq hatchdatax (subst (cons 44 cursorY)(assoc 44 hatchdatax) hatchdatax))
(entmod hatchdatax)
(setq hatchent (cdr (car hatchdatax)))
)
)
(setq centerpoint cursorpoint)
)
(progn
  (if VALEUR
    (progn
      (if (listp (read VALEUR))
        (progn
          (setq Vcoord (read VALEUR))
          ;;(grdraw centerpoint cursorpoint 12 1)
          (setq hatchentData (entget hatchent))
(setq hatchdatax (subst (cons 43 (car Vcoord))(assoc 43 hatchentData) hatchentData))
(setq hatchdatax (subst (cons 44 (cadr Vcoord))(assoc 44 hatchdatax) hatchdatax))
(entmod hatchdatax)
(setq hatchent (cdr (car hatchdatax)))
(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 252 Vcoord 5 A_cecolor 252 252)
(setq activeMODE nil)          
    )
)
)
)
)
)
)
(DHMTEXT 254 input A_hpscale 252 A_hpang 252 A_hpname 252 centerpoint 12 A_cecolor 252 252)
)
(setq Operation nil)

	)	 
)
      
(if (/= #op 4)(setq lastOrigin centerpoint))      
(setq LastAng A_hpang)
(setq Lastinput input)
)
(princ)
(DhatchFinishMode)
  
)

				;;
;;				;;
;;	DHATCH 	function	;;
;;				;;








;;				;;
;;	ANGLE SHOW		;;
;;				;;
				;;
(defun grdraw_angle (/ colorvar)
  (grdraw centerpoint cursorpoint 4 1)
  (grdraw centerpoint
          (polar centerpoint 0 (distance centerpoint cursorpoint))
          4
          1
  )
  (if arcent
    (progn (vl-cmdf "._erase" arcent "") (setq arcent nil))
  )
  (setq colorvar (getvar "cecolor"))
  (setvar "cecolor" "4")
  (vl-cmdf "_arc"
           "_C"
           centerpoint
           (polar centerpoint
                  0
                  (/ (distance centerpoint cursorpoint) 2)
           )
           (polar centerpoint
                  (angle centerpoint cursorpoint)
                  (/ (distance centerpoint cursorpoint) 2)
           )
  )
  (setq arcent (entlast))
  (setvar "cecolor" colorvar)
)
				;;
;;				;;
;;	ANGLE SHOW		;;
;;				;;





;;				;;
;;	MTEXT SHOW		;;
;;				;;
				;;
(defun DHMTEXT (bakgr coord 1scale 1col 2angle 2col 3name 3col 4orig 4col
		#5col	;;couleur du hatch (String)
		5col	;couleur du texte
                6col    ;couleur du PATfile
		)

(if mtextdata
  (progn (vl-cmdf "._erase" mtextdata "")
         (setq mtextdata nil)
  )
)

(setq coo (read #5col))
(if (and (= (strcase #5col) "BYLAYER"))
  (setq coo (cdr
              (assoc 62 (entget (tblobjname "layer" (getvar "CLAYER"))))
            )
  )
)
(if (and (= (strcase #5col) "BYBLOCK"))
  (setq coo 7)
)
(setq coo (strcat "\\C" (itoa coo) "; "))

(if (member (strcase 3name) basehatch)
  (setq patfilename bhatchf)
  (setq patfilename (strcat 3name ".pat"))
)
  
(setq MTextSTRING (strcat "\\pxsm1.5,ql;{\\fArial|b1|i0|c0|p34;\\L\\O - D H A T C H  menu -\\P\\ps*,q*;\\l\\o}"
                          "{\\fArial|b1|i0|c0|p34;\\C" (itoa 6col) mess12 PATfilename "\\P"
                          "\\C" (itoa 1col) mess8 (rtos 1scale) "\\P"
			  "\\C" (itoa 2col) mess9 (rtos (rtd 2angle)) "\\P"
			  "\\C" (itoa 3col) mess10 3name "\\P"
			  "\\C" (itoa 4col) mess11 (vl-princ-to-string 4orig) "\\P"
			  "\\C" (itoa 5col) "color:" coo #5col
                          "}"
		  )
)   

             (setq ViewSize (getvar "VIEWSIZE"))
	     (setq MTextData
		    (entmakex
		      (list
			(cons 0 "MTEXT")
			(cons 100 "AcDbEntity")
			(cons 100 "AcDbMText")
			(cons 1 MTextSTRING)
                        (cons 10
			      (polar (cadr coord) 0 (/ ViewSize 90.0))
			)
			(cons 40 (/ ViewSize 70.0))
			(cons 50 0.0)
			(cons 62 250)
			(cons 71 1)
			(cons 72 5)
			(cons 90 1)
			(cons 63 bakgr)
			(cons 45 1.2)
		      )
		    )
	     )
      )
				;;
;;				;;
;;	MTEXT SHOW		;;
;;				;;






;;				;;
;;	FINISH MODE		;;
;;				;;
				;;
(defun dhatchfinishmode ()
  (if mtextdata
    (progn (vl-cmdf "._erase" mtextdata "")
           (setq mtextdata nil)
    )
  )
  (if arcent
    (progn (vl-cmdf "._erase" arcent "") (setq arcent nil))
  )
  (if entassoc ;(progn
 ;(vl-cmdf "._-hatchedit" hatchent "_DI" )
    (vl-cmdf "._-hatchedit" hatchent "_AS" "_S" "_non" entassoc "" "") ;)
 ;(progn
 ;(vl-cmdf "._-hatchedit" hatchent "_DI" )
 ;(vl-cmdf "._-hatchedit" (entlast) "_AS" "_non" ficpoint "")   
 ;)
  )
  (if a_hpscale
    (setvar "HPSCALE" a_hpscale)
  )
)
				;;
;;				;;
;;	FINISH MODE		;;
;;				;;






  

;;				;;
;;	HATCH UPDATE		;;
;;				;;
				;;
(defun modifhatch (hatch col rot sca orig)
  (redraw)
  (if hatchdata
    (progn (setq cursorx (car orig))
           (setq cursory (cadr orig))
           (setq hatchdatax (subst (cons 43 cursorx) (assoc 43 hatchentdata) hatchdata))
           (setq hatchdatax (subst (cons 44 cursory) (assoc 44 hatchdatax) hatchdatax))
           ;;scale
           (if (not (assoc 41 hatchdatax))
             (setq hatchdatax (append hatchdatax (list (cons 41 sca))))
             (setq hatchdatax (subst (cons 41 sca) (assoc 41 hatchdatax) hatchdatax))
           )
           ;;HatchPattern
           (setq hatchdatax (subst (cons 2 hatch) (assoc 2 hatchdatax) hatchdatax))
           ;;Color
           (if (eq (strcase col) var256) ;BYLAYER
             (setq hatchdatax (vl-remove (assoc 62 hatchdatax) hatchdatax))
           )
           (if (eq (strcase col) var0) ;BYBLOCK
             (setq col "0")
           )
           (if (numberp (read col))
             (progn
               (if (not (assoc 62 hatchdatax))
                 (setq hatchdatax (append hatchdatax (list (cons 62 (read col)))))
                 (setq hatchdatax (subst (cons 62 (read col))
                                         (assoc 62 hatchdatax)
                                         hatchdatax
                                  )
                 )
               )
             )
           )
           (if hatchent
             (progn (command "._erase" hatchent "") (setq hatchent nil))
           )
           (setq hatchent (entmakex hatchdatax))
           (setq hatchdata hatchdatax)
    )
  )
)
				;;
;;				;;
;;	HATCH UPDATE		;;
;;				;;


;(setq acadftype (findfile bhatchf))

;(setq hatchlist (gethatchlin (findfile bhatchf)))

;|						;;
	hatchlist creator			;;
						|;
						;;
(defun gethatchlin (acadftype / lino l1 commapos alllist)
  (setq hatchlist nil
        alllist nil
  )
  (if (setq fullpat (findfile acadftype))
    (progn (setq lino (open fullpat "r"))
           (while (setq l1 (read-line lino))
             (if (and (eq (substr l1 1 1) "*")
                      (setq commapos (vl-string-search "," l1))
                 )
               (setq alllist (append alllist (list (substr l1 2 (1- commapos)))))
             )
           )
    )
  )
  (close lino)
  (if alllist
    (setq hatchlist (mapcar 'strcase alllist))
  )

(setq BaseHAtch hatchlist)
  
  (setq acadenv (getenv "ACAD"))
  (while (setq symb (vl-string-search ";" acadenv))
    (setq folder (substr acadenv 1 symb))
    (setq patlist (vl-directory-files folder "*.pat" 1))
    (if patlist
      (progn (setq patlist (mapcar '(lambda (x) (vl-filename-base (strcase x)))
                                   patlist
                           )
             )
             (setq patlist (vl-remove "ACADISO" patlist))
             (setq patlist (vl-remove "ACAD" patlist))
             (if patlist
               (setq hatchlist (append hatchlist patlist))
             )
      )
    )
    (setq acadenv (substr acadenv (+ symb 2)))
  )
  (setq patlist nil)
  (setq patlist (vl-directory-files acadenv "*.pat" 1))
  (if patlist
    (progn (setq patlist (mapcar '(lambda (x) (vl-filename-base (strcase x)))
                                 patlist
                         )
           )
           (setq hatchlist (append hatchlist patlist))
    )
  )
)
						;;
;|						|;







;;				;;
;;	ONerror			;;
;;				;;
				;;
(defun *error* (msg)
(DhatchFinishMode)  
(redraw)
(princ (strcat "\n" msg))
)
				;;
;;				;;
;;	ONerror			;;
;;				;;



